/*******************************************************************************
 * Copyright (c) 2010 s IT Solutions AT Spardat GmbH .
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *     s IT Solutions AT Spardat GmbH - initial API and implementation
 *******************************************************************************/
package org.openxma.dsl.pom.resource;

import org.eclipse.emf.ecore.EObject;
import org.eclipse.emf.ecore.resource.Resource;
import org.eclipse.xtext.naming.IQualifiedNameProvider;
import org.eclipse.xtext.resource.IReferenceDescription;
import org.openxma.dsl.core.resource.CoreDslResourceDescription;

import at.spardat.xma.guidesign.XMAComponent;
import at.spardat.xma.guidesign.util.GuidesignSwitch;

import com.google.common.base.Predicate;
import com.google.common.collect.Iterables;

public class XmaResourceDescription extends CoreDslResourceDescription {
    private static final Predicate<EObject> EXPORTED_OBJECTS_FILTER = new ExportedObjectsFilter();

    public XmaResourceDescription(Resource resource, IQualifiedNameProvider nameProvider) {
        super(resource, nameProvider);
    }

    @Override
    protected Predicate<EObject> getExportedObjectsFilter() {
        return EXPORTED_OBJECTS_FILTER;
    }

    @Override
    public Iterable<IReferenceDescription> getReferenceDescriptions() {
        return Iterables.emptyIterable();
    }

    private static class ExportedObjectsFilter extends GuidesignSwitch implements Predicate<EObject> {

        public boolean apply(EObject input) {
            Boolean filtered = (Boolean) doSwitch(input);
            return filtered;
        }

        @Override
        public Object defaultCase(EObject object) {
            return Boolean.FALSE;
        }

        @Override
        public Object caseXMAComponent(XMAComponent object) {
            return true;
        }

    }
}
